/*
pot est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique
Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include "commun.h"


/* affiche un fichier sur stdout */
void view(char *chemin)
{
  /* initialisation des variables */
  int n = 0;
  char nom[10];
  FILE *pot;

  pot = fopen(chemin, "r");
  erreur(pot);

  /* affichage */
  while(fscanf(pot,"%9s",nom) != EOF)
    {
      n++;
      printf("%-13s",nom);
      if (n > 5)
        {
	  n = 0;
	  printf("\n");
        }
    }
  fclose(pot);
  printf("\n");
}


/* supprime un login de ~/.pot.pot */
void suppr(char *chemin,void *del)
{
  /* initialisation des variables */
  char nom[10];
  char *chemind;

  FILE *potd;
  FILE *pot = fopen(chemin, "r");

  if ( ( chemind = malloc( (strlen(chemin)+2)*sizeof(char) ) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      exit(0);
    }
 
  erreur(pot);
  strcpy(chemind,chemin);
  strcat(chemind,"2");
  /* verifier que chemind n'existe pas avant l'ouverture */
  potd = fopen(chemind, "a+");
  erreur(potd);
  while(fscanf(pot,"%9s",nom) != EOF)
    {
      if( strcmp(nom , del) != (int)NULL) 
        {
	  fprintf(potd , "%s\n" , nom);
        }
    }
  fclose(pot);
  fclose(potd);
  rename(chemind,chemin);
  remove(chemind);
}


/* gestion des erreurs  l'ouverture d'un flux */
void erreur(FILE *tube)
{
  if (!tube)
    {
      fprintf( stderr , "Erreur : %s\n" , strerror(errno));
      exit(0);
    }
}


/* remplit la stucture liste_connecte par rapport  localhost, renvoie le nombre de "pot", -1 si echoue */
int finger(char *chemin)
{
  /*initialisation des variables */
  int utm;
  char login[10];
  
  struct utmp whereis;
  struct passwd *user_info;
  
  FILE *pot;
  
  /* combien de personne dans la structure */
  int compteur = 0;
  
  /* Gestion de la liste des connectes */
  depart.next = NULL;
  depart.previous = NULL;
  connecte = &depart;

  /* Reprogrammation d'un finger sur mesure */

  /* ouverture des flux */
  if ( ( utm = open(UTMP, 0) ) < 0 )
    {
      fprintf(stderr,"***Warning*** %s\n" , strerror(errno) );
      return -1;
    }

  if ((pot = fopen(chemin, "r")) == NULL )
    {
      fprintf(stderr,"Pot.pot n'existe pas.\nPour plus d'informations tapez : pot -h\n");
      return -1;
    }

  /* lecture d'utmp */
  while ( read(utm,  (char *)&whereis, sizeof(struct utmp)) == sizeof(struct utmp))
    {
      /* Gain de temps car tous les logins ont au moins 2 caracteres */
      if (strlen(whereis.ut_user) > 1 )
        {
	  /* Recuperation des informations sur le login */
	  if ( (user_info = getpwnam(whereis.ut_user) ))
            {
	      /* la personne est-elle dans le fichier ~/.pot.pot */
	      while ( fscanf( pot , "%s" , login ) != EOF )
                {
		  if ( !strcmp( login , whereis.ut_user ) )
                    {
		      compteur++;

		      /* rajoute la personne connect dans la structure liste-connecte */
		      if (  ! ajouteliste ( whereis.ut_user , whereis.ut_host , whereis.ut_line , user_info ) )
			return -1;
                    }
                }
	      /* reinitialisation du flux pot */
	      fseek( pot , 0 , SEEK_SET );
            }
        }
    }

  /* fermeture des flux */
  fclose( pot );
  close( utm );
  
  return compteur;
}


/* la fonction rajoute un connecte, 0 quand choue, 1 sinon */
int ajouteliste(char *login , char *ordi , char *tty , struct passwd *ki)
{
  char *sal[1];
  
  /* Cration de la structure suivante */

  if ( ( connecte = (struct liste_connecte *) malloc(sizeof(struct liste_connecte)) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }

  connecte->next = depart.next;
  depart.next = connecte;
  connecte->previous = &depart;
  if( connecte->next != NULL)
    connecte->next->previous = connecte;

  /* remplissage de la structure */

  /* login */
  if ( ( connecte->login = (char *) calloc(strlen(login) + 1, sizeof(char)) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }
  strcpy(connecte->login,login);

  /* ordi */
  if ( ( connecte->ordi = (char *) calloc(strlen(ordi) + 1, sizeof(char)) ) == NULL )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }
  strcpy(connecte->ordi,ordi);
  
  /* nom */
  if ( ki->pw_gecos[0] != ',' )
    {
      if ( ( connecte->nom = (char *) calloc(strlen(ki->pw_gecos) + 1, sizeof(char)) ) == NULL )
        {
	  fprintf ( stderr , "Allocation de memoire impossible\n" );
	  return 0;
        }
      strcpy( connecte->nom,strtok(ki->pw_gecos,",") );
    }
  else
    {
      if ( ( connecte->nom = (char *) malloc (sizeof("???")) ) == NULL )
        {
	  fprintf ( stderr , "Allocation de memoire impossible\n" );
	  return 0;
        }
      strcpy(connecte->nom,"???");
    }

  
  /* talk */
  connecte->talk = talkable(tty);
  
  /* salle */
  if ( ! kelsal(ordi , sal) )
    {
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }
  connecte->salle = calloc ( strlen(*sal) + 1, sizeof(char) );
  strcpy(connecte->salle , *sal);
  
  return 1;
}


/* correspondance entre le nom de l'ordi et la salle, 0 quand choue, 1 sinon */
int kelsal(char *ordi,char **salle)
{
  /* si pas de nom d'ordi */
  if ( strlen ( ordi ) == 0 )
    {
      if ( ( *salle = (char *) malloc(sizeof("console")) ) == NULL )
	return 0;
      strcpy ( *salle , "console" );
      return 1;
    }

  /* ordi xsme */ 
  if ( ! strncmp( ordi , "xsme" , 4 ) )
    {
      switch( ordi[4] )
        {
	case '1' :
	  if ( ( *salle = (char *) malloc(sizeof("FB 115")) ) == NULL )
	    return 0;
	  strcpy(*salle,"FB 115");
	  break;
	  
	case '0' :
	  if ( ( *salle = (char *) malloc(sizeof("FB 115")) ) == NULL )
	    return 0;
	  strcpy(*salle,"FB 115");
	  break;
	  
	case '4' :
	  if ( ( *salle = (char *) malloc(sizeof("Sas A-B")) ) == NULL )
	    return 0;
	  strcpy(*salle,"Sas A-B");
	  break;
	  
	case '6' :
	  if ( ( *salle = (char *) malloc(sizeof("FB 204")) ) == NULL )
	    return 0;
	  strcpy(*salle,"FB 204");
	  break;
	  
	case '2' :
	  switch(ordi[5])
	    {
	    case '3' :
	      if ( ( *salle = (char *) malloc(sizeof("Millibar")) ) == NULL )
		return 0;
	      strcpy(*salle,"Millibar");
	      break;

	    default :
	      if ( ( *salle = (char *) malloc(sizeof("FB 207")) ) == NULL )
		return 0;
	      strcpy(*salle,"FB 207");
	      break;
	    }
	  break;
	case '5' :
	  if ( ( *salle = (char *) malloc(sizeof("RB 123")) ) == NULL )
	    return 0;
	  strcpy(*salle,"RB 123");
	  break;

	case '3' :
	  switch(ordi[5])
	    {
	    case '0' : ;
	    case '1' : ;
	    case '2' : ;
	    case '3' : ;
	    case '4' :
	      if ( ( *salle = (char *) malloc(sizeof("FA 2me")) ) == NULL )
		return 0;
	      strcpy(*salle,"FA 2me");
	      break;

	    case '5' : ;
	    case '6' : ;
	    case '7' : ;
	    case '8' : ;
	    case '9' :
	      if ( ( *salle = (char *) malloc(sizeof("FA 1er")) ) == NULL )
		return 0;
	      strcpy(*salle,"FA 1er");
	      break;
	    }
	  break;

	case '7' :
	  if ( ( *salle = (char *) malloc(sizeof("FB 207")) ) == NULL )
	    return 0;
	  strcpy(*salle,"FB 207");
	  break;

	default:
	  if ( ( *salle = (char *) malloc( (strlen(strtok(ordi,"."))+2)*sizeof(char)) ) == NULL )
	    return 0;
	  strcpy(*salle,"(");
	  strcat(*salle,strtok(ordi,"."));
	  strcat(*salle,")");
	  break;
        }
    }

  /* ordi pcxsme */
  else if ( ! strncmp( ordi , "pcxs" , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("FB 200")) ) == NULL )
	return 0;
      strcpy(*salle,"FB 200");
    }
  

  /* ordi smepc */
  else if ( ! strncmp( ordi , "smep" , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("FB 113")) ) == NULL )
	return 0;
      switch( ordi[5] )
        {
	case 'b' :
	  strcpy(*salle,"FB 113");
	  break;
	  
	case 'd' :
	  strcpy(*salle,"FB 114");
	  break;
	  
	case 'e' :
	  strcpy(*salle,"FB 108");
	  break;
	  
	case 'f' :
	  strcpy(*salle,"FB 104");
	  break;
	  
	case 'g' :
	  strcpy(*salle,"FB 101");
	  break;
	  
	case 'h' :
	  strcpy(*salle,"FB 209");
	  break;	  
        }
    }

  /* BUTC */
  else if ( ! strncmp( ordi , "pcbu" , 4 ) )
    {
      switch( ordi[9] )
        {
	case '4' :
	  if ( ( *salle = (char *) malloc(sizeof("BUBF 4")) ) == NULL )
	    return 0;
	  strcpy(*salle,"BUBF 4");
	  break;
	case '5' :
	  if ( ( *salle = (char *) malloc(sizeof("BUBF 5")) ) == NULL )
	    return 0;
	  strcpy(*salle,"BUBF 5");
	  break;
	case 'z' :
	  if ( ( *salle = (char *) malloc(sizeof("BUBF Mezzanine")) ) == NULL )
	    return 0;
	  strcpy(*salle,"BUBF Mezzanine");
	  break;
	case 'l' :
	  if ( ( *salle = (char *) malloc(sizeof("BU Royallieu")) ) == NULL )
	    return 0;
	  strcpy(*salle,"BU Royallieu");
	  break;
        }
    }

  /* TX de la BUBF */
  else if ( ! strncmp( ordi , "txbu" , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("TX BUTC")) ) == NULL )
	return 0;
      strcpy(*salle,"TX BUTC");
    }

  /* GSU */
  else if ( ! strncmp( ordi , "pcgsu" , 5 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("(gsu)")) ) == NULL )
	return 0;
      strcpy(*salle,"(gsu)");
    }

  /* accueil */
  else if ( ! strncmp( ordi , "sgix" , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("Accueil")) ) == NULL )
	return 0;
      strcpy(*salle,"Accueil");
    }

  /* FC 224 */
  else if ( ! strncmp( ordi , "c224" , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("FC 224")) ) == NULL )
	return 0;
      strcpy(*salle,"FC 224");
    }

  /* Adresse IP... */
  else if ( ! strncmp( ordi , "172." , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("(???)")) ) == NULL )
	return 0;
      strcpy(*salle,"(???)");
    }

  /* ??? */
  else if ( ! strncmp( ordi , "hp" ,2 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("(hp)")) ) == NULL )
	return 0;
      strcpy(*salle,"(hp)");
    }

  /* Modem */
  else if ( ! ( strncmp( ordi , "ppp-" , 4 ) ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("(Modem)")) ) == NULL )
	return 0;
      strcpy(*salle,"(Modem)");
    }

  /* MDE  */
  else if ( ! ( strncmp( ordi , "pcbd" , 4 ) && strncmp( ordi , "macb" , 4 ) && strncmp( ordi , "ncd38" , 5 ) ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("MDE")) ) == NULL )
	return 0;
      strcpy(*salle,"MDE");
    }

  /* Labo de Langue */
  else if ( ! strncmp( ordi , "dmel" , 4 ) )
    {
      if ( ( *salle = (char *) malloc(sizeof("Labo de Langue")) ) == NULL )
	return 0;
      strcpy(*salle,"Labo de Langue");
    }

  /* Endroit inconnu */
  else
    {
      if ( ( *salle = (char *) malloc ( (strlen(strtok(ordi,".")+3) * sizeof(char) ) ) ) == NULL )
	return 0;
      strcpy(*salle,"(");
      strcat(*salle,strtok(ordi,"."));
      strcat(*salle,")");
    }

  return 1;
}


/* la fonction retourne 1 si on peut communiquer avec la personne sinon 0 */
short talkable( char *tty )
{
  /* initialisation des variables */
  struct stat ttystatus;
  char *buffer;

  /* Si sur samba */
  if ( ! strcmp(tty,"smb") )
    return 0;

  /* recuperation du nom de la console */
  if ( ( buffer = (char *)malloc((strlen(tty)+6)*sizeof(char)) ) == NULL )
    {      
      fprintf ( stderr , "Allocation de memoire impossible\n" );
      return 0;
    }

  strcpy( buffer , "/dev/" );
  strcat(buffer,tty);

  /* recuperation du mode d'ecriture de la console */
  if (stat(buffer, &ttystatus) < 0)
      return 0;

  /* retour de la fonction : console ecrivable ou non */
  if( (ttystatus.st_mode & TALKABLE) == TALKABLE )
    return 1;
  else
    return 0;
}


#ifdef SAMBA
/* la fonction scanne les connecte par samba (PC), renvoie le nombre de "pot", -1 si echoue */
int samba(char *chemin)
{
  /* initialisation des variable */
  int compteur = 0;
  int tmp = 1;
  
  char login[10];
  char ordi[10];
  char *talk = "smb";
  
  struct passwd* user_info;
  
  FILE *smb;
  
  /* ouverture de la commande sambastatus */
  smb = (FILE *) popen("/usr/local/samba/bin/smbstatus -b | cut -c9-28 | grep -f $HOME/.pot.pot","r");
  erreur(smb);

  /* lecture du flux */
  while( (fscanf(smb,"%s",login) != EOF) && (fscanf(smb,"%s",ordi) != EOF) )
    {
      if ( ! (user_info = getpwnam(login)) )
	break;
      compteur++;

      /* La personne a-elle une console active */
      connecte = &depart;

      while ( (connecte = connecte->next) != NULL )
        {
	  tmp = 1; 
		  
	  if ( ! strcmp(login,connecte->login) )
            {
	      tmp = 0;
	      break;
            }
        }
      /* rajoute la personne connect dans la structure liste-connecte */
      if (tmp == 1)
        {
	  connecte = &depart;
	  if (  ! ajouteliste ( login , ordi , talk , user_info ) )
	    return -1;
        }
      
    }
  pclose(smb);
  return compteur;
}
#endif


/* efface la liste chaine */
int free_liste( void )
{
  struct liste_connecte *efface;
  
  if ( (efface = depart.next) == NULL )
    return 0;
  
  /* Ca marche mais c est vraiment pas beau */
  while( efface->next != NULL )
    {
      free( efface->login );
      free( efface->ordi );
      free( efface->nom );
      free( efface->salle );
      efface = efface->next;
      free( efface->previous );
    }

  free( efface->login );
  free( efface->ordi );
  free( efface->nom );
  free( efface->salle );
  free( efface );

  return 0;
}
