/*
pot est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
ni explicite ni implicite, y compris les garanties de commercialisation ou
d'adaptation dans un but spcifique. Reportez-vous  la Licence Publique
Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <errno.h>
#include <stdlib.h>
#include <utmp.h>
#include <sys/types.h>
#include <fcntl.h>
#include <pwd.h>
#include <locale.h>
#include <sys/stat.h>
#include <wait.h>

#define VERSION "3.0.1"

/* chemin de utmp */
#ifdef __osf__ /* Pour vega... */
#define UTMP "/var/adm/utmp"
#else
#define UTMP "/var/run/utmp"
#endif

/* tty est inscriptible si le mode est 220 */
#define TALKABLE 0220

/* Liste chain des connects */
struct liste_connecte
{
  int talk;
  char *login;
  char *ordi;
  char *nom;
  char *salle;
  struct liste_connecte *next;
  struct liste_connecte *previous;
} *connecte , /* *precedent ,*/ depart;


/* declaration des prototypes */

/* affiche un fichier sur stdout */
void view(char *chemin);

/* supprime un login de ~/.pot.pot */
void suppr(char *chemin,void *optarg);

/* gestion des erreurs  l'ouverture d'un flux */
void erreur(FILE *pipe);

/* remplit la stucture connecte par rapport  localhost, retourne le nombre de connect, -1 si echoue  */
int finger(char *chemin);

/* la fonction rajoute un connecte, 0 quand choue, 1 sinon */
int ajouteliste(char *login , char *ordi , char *tty , struct passwd *ki);

/* correspondance entre le nom de l'ordi et la salle, 0 quand choue, 1 sinon */
int kelsal(char *ordi,char **salle);

/* la fonction retourne 1 si on peut communiquer avec la personne sinon 0 */
short talkable( char *tty );

/* la fonction scanne les connecte par samba (PC) */
int samba(char *chemin);

/* efface la liste chaine */
int free_liste( void );
