/*
est pot un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus
de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "console.h"
#include "commun.h"
#include "potgtk.h"

/* fonction principal */
int main(int argc , char *argv[] /*, char *envp[]*/)
{
  /* initialisation des variables */
  int c , j;
  char *chemin;
  FILE *pot;
  
  /* recueil du chemin de pot.pot et de pot.pot.linux */
  if ( ( chemin = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
    {
      fprintf( stderr , "Allocation de memoire impossible" );
      return -1;
    }
  strcpy ( chemin , getenv("HOME") );
  strcat ( chemin , "/.pot.pot" );

  /* Les arguments */
  while ( ( c = getopt(argc,argv,"hlgtr:") ) != -1 ) 
    switch ( c )
      {
	/* aide */
      case 'h' :
	printf("Pot %s par Fabien Carrion et Guillaume Pinot\n"
	       "G.U.I. par Tahorg\n\n"
	       "utilisation : %s [login1 [login2...] | -r login | -l | -h | -t | -g] ;\n"
	       "\tlogin1 login2\trajoute des logins dans votre liste de \"pot\" ;\n"
	       "\t-r\t\tenlve un login de votre liste de \"pot\" ;\n"
	       "\t-l\t\taffiche votre liste de \"pot\" ;\n"
	       "\t-t\t\taffiche votre liste de \"pot\" sur le serveur linux ;\n"
	       "\t-g\t\tlance potgtk, la version Graphique ;\n"
	       "\t-h\t\taffiche ce message d'aide.\n"
	       "\n\thttp://wwwetu.utc.fr/~pinotgui/\n\n",VERSION,argv[0]);
	return 0;

	/* Lance potgtk (en graphique) */
      case 'g' :
	return potgtk(chemin , argc , argv);
	
	/* visualisation des logins enregistrs pour localhost */
      case 'l' :
	view(chemin);
	return 0;
	
	/* visualisation des logins enregistrs pour linux */
      case 't' :
	strcat(chemin,".linux");
	view(chemin);
	return 0;
	
	/* suppression d'un login pour localhost */
      case 'r' :
	suppr(chemin,optarg);
	return 0;
	
	/* arguments invalide */
      default  :
	printf("Tapez %s -h\n",argv[0]);
	return 0;
	
      }



  /* ajout le login dans le fichier ~/.pot.pot */
  if ( argc >= 2 )
    {
      pot = fopen(chemin, "a");
      erreur(pot);

      /* verifier que le login existe !!! */
      for(j = 0 ; argv[++j] != 0 ; fprintf( pot , "%s\n" , argv[j] ) );
      return 0;
    }

  /* execution en mode console du programme */
  console ( chemin );
  return 0;
}
